N = 181;%接受传感器数目
%读取软件中扫描得出的正弦图
R2 = dlmread('lung_sinogram');
%设置快速傅立叶变换的宽度
width = 2^nextpow2(size(R2,1));

%%对投影值进行傅立叶变换并滤波
%傅立叶变换
proj_fft = fft(R2,width);
%R-L滤波算法设置
filter = 2*[0:(width/2-1),width/2:-1:1]'/width;
%滤波结果放在proj_filtered中
proj_filtered = zeros(width,180);
for i = 1:180 
    proj_filtered(:,i) = proj_fft(:,i).*filter;
end

%%逆快速傅立叶变换并反投影
%逆快速傅立叶变换
proj_ifft = real(ifft(proj_filtered)); 

%反投影到x轴，y轴
M = 128
fbp = zeros(M); % 假设初值为0
for i = 1:180
    rad = (theta(i)*pi)/180;%弧度
    for x = 1:M
        for y = 1:M
            %{
            %最近邻插值法
            t = round((x-M/2)*cos(rad)-(y-M/2)*sin(rad));%将每个元素舍X入到最接近的整数。
            if t<size(R,1)/2 && t>-size(R,1)/2
                fbp(x,y)=fbp(x,y)+proj_ifft(round(t+size(R,1)/2),i);
            end
            %}
            t_temp =(x-M/2) * sin(rad) + (y-M/2) * cos(rad) + N/2;%求重建图像的坐标点在各个角度的一维傅里叶变换图中的位置，以便取值和后续操作
             %最近邻插值法
            t = round(t_temp) ;
            if t>0 && t<=256
                fbp(x,y)=fbp(x,y)+proj_ifft(t,i);
            end
        end
    end
end
dlmwrite('FBP.txt',fbp);%将得到的重建后的图像数据写入文件
% 显示结果
figure
subplot(1,4,1),imshow(proj_fft),title('傅立叶变换')
subplot(1,4,2),imshow(proj_filtered),title('傅立叶变换+滤波')
subplot(1,4,3),imshow(mat2gray(proj_ifft)),title('逆傅立叶变换')
subplot(1,4,4),imshow(mat2gray(fbp)),title('反投影变换后的图像')

